#ifndef _XMP_HEADER_H_
#define _XMP_HEADER_H_
#include <math.h>
#include <mpi.h>
#include <limits.h>
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include"omrpc_mpi_lib.h"

#define TMP_DR_ROOT "/work/PFLOPS/tsuji/xmp/var/yml/dr"
#define TMP_DR_WORK "/work/PFLOPS/tsuji/xmp/var/yml/dr/tmp"

typedef double real;
typedef int32_t integer;  
typedef struct{
 int n,m;
 double *data;
}Matrix; 

typedef struct{
  integer n;
  integer *v;
}integer_vector;

FILE *fp_output_txt;
FILE *fp_trace_txt;
FILE *fp_status_txt;

omrpc_mpi_node_t *node;
MPI_Comm         comm_parent;

void xmp_start_rex(int argc, char **argv);
void xmp_finish_rex();
void xmp_start_component(int argc, char **argv);
void xmp_finish_component();

void xmp_read_integer        (char *prog_name, char *dir, char *fname, integer *i);
void xmp_read_integer_vector (char *prog_name, char *dir, char *fname, integer_vector *v);
void xmp_read_Matrix         (char *prog_name, char *dir, char *fname, Matrix *m);
void xmp_read_xmp_dbl_array2 (char *prog_name, char *dir, char *fname, double **m, char *xmp_description);
void xmp_write_integer       (char *prog_name, char *dir, char *fname, integer *i);
void xmp_write_integer_vector(char *prog_name, char *dir, char *fname, integer_vector *v);
void xmp_write_Matrix        (char *prog_name, char *dir, char *fname, Matrix *m);
void xmp_write_xmp_dbl_array2(char *prog_name, char *dir, char *fname, double **m, char *xmp_description);

void **xmp_malloc_matrix(int, int, size_t);
void xmp_free_matrix(void ***, int, int, size_t);
#endif  // _XMP_HEADER_H_
